#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1700four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1700four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four17004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four17004xi = {
                1:'1002x-959y982z',
                2:'1012x-135y1358z',
                3:'101x-77y1695z',
                4:'1022x-631y1202z',
                5:'1031x-83y1348z',
                6:'1048x-29y1337z',
                7:'1058x-912y968z',
                8:'1062x-1312y198z',
                9:'1064x-582y1190z',
                10:'1103x-531y1178z',
                11:'1112x-861y954z',
                12:'1130x-1256y181z',
                13:'1141x-477y1166z',
                14:'115x-326y1664z',
                15:'1163x-807y940z',
                16:'1175x-420y1153z',
                17:'118x-81y1693z',
                18:'1196x-1196y164z',
                19:'1206x-362y1141z',
                20:'1212x-750y925z',
                21:'1235x-301y1128z',
                22:'1258x-1133y148z',
                23:'1258x-690y911z',
                24:'1260x-238y1115z',
                25:'1282x-173y1102z',
                26:'1300x-107y1089z',
                27:'1300x-627y897z',
                28:'1314x-39y1076z',
                29:'1317x-1066y131z',
                30:'1339x-561y882z',
                31:'1372x-996y114z',
                32:'137x-83y1692z',
                33:'138x-334y1660z',
                34:'1423x-924y97z',
                35:'1456x-523y919z',
                36:'1470x-849y80z',
                37:'1513x-771y63z',
                38:'1552x-691y46z',
                39:'156x-84y1690z',
                40:'1586x-609y29z',
                41:'1616x-525y12z',
                42:'163x-342y1657z',
                43:'173x-1647y382z',
                44:'175x-83y1688z',
                45:'188x-347y1653z',
                46:'195x-80y1686z',
                47:'215x-351y1649z',
                48:'215x-75y1684z',
                49:'235x-69y1682z',
                50:'242x-353y1645z',
                51:'255x-60y1679z',
                52:'259x-1639y366z',
                53:'270x-353y1640z',
                54:'274x-50y1676z',
                55:'278x-676y1534z',
                56:'293x-38y1674z',
                57:'299x-350y1636z',
                58:'311x-23y1671z',
                59:'320x-674y1527z',
                60:'328x-346y1631z',
                61:'329x-7y1667z',
                62:'345x-1627y349z',
                63:'358x-340y1626z',
                64:'362x-670y1519z',
                65:'387x-331y1621z',
                66:'404x-663y1511z',
                67:'417x-320y1616z',
                68:'431x-1610y333z',
                69:'447x-307y1611z',
                70:'447x-653y1504z',
                71:'453x-960y1327z',
                72:'476x-292y1605z',
                73:'490x-641y1496z',
                74:'504x-274y1599z',
                75:'509x-946y1316z',
                76:'516x-1588y316z',
                77:'532x-626y1487z',
                78:'533x-254y1594z',
                79:'560x-232y1588z',
                80:'565x-930y1305z',
                81:'574x-608y1479z',
                82:'586x-208y1581z',
                83:'599x-1562y299z',
                84:'611x-181y1575z',
                85:'616x-587y1471z',
                86:'620x-909y1294z',
                87:'627x-1168y1063z',
                88:'635x-152y1569z',
                89:'657x-564y1462z',
                90:'658x-122y1562z',
                91:'675x-886y1283z',
                92:'679x-89y1555z',
                93:'681x-1531y282z',
                94:'693x-1142y1050z',
                95:'697x-537y1453z',
                96:'698x-55y1548z',
                97:'715x-19y1541z',
                98:'728x-859y1272z',
                99:'736x-508y1444z',
                100:'758x-1113y1036z',
                101:'762x-1496y266z',
                102:'774x-477y1435z',
                103:'781x-829y1261z',
                104:'811x-442y1426z',
                105:'821x-1080y1023z',
                106:'833x-796y1249z',
                107:'840x-1456y249z',
                108:'846x-405y1417z',
                109:'86x-1650y399z',
                110:'879x-366y1407z',
                111:'883x-1043y1009z',
                112:'883x-759y1238z',
                113:'910x-324y1398z',
                114:'917x-1412y232z',
                115:'931x-719y1226z',
                116:'939x-280y1388z',
                117:'943x-1003y995z',
                118:'966x-234y1378z',
                119:'977x-677y1214z',
                120:'990x-185y1368z',
                121:'991x-1364y215z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1700four4xi" usage = "target function for charge17004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1700four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1700FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1700FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1700FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1700FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1700FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four17004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1700FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1700FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1700FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four17004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four17004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1700FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1700FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1700FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1700four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    